module MeterpreterDetection_Timing;

# This event captures polls.
event http_request(c: connection, method: string, original_URI: string,
    unescaped_URI: string, version: string)
	{
	if ( c$id !in win_polling_data )
		win_polling_data[c$id] = polling_state();

	local current_state = win_polling_data[c$id];

	# FIXME: We don't use length for HTTP polls yet
	next_step(current_state, network_time(), 0, c$uid);

	if ( current_state$max_index <= threshold &&
	     current_state$current_index <= threshold)
		return;

	local trip = MeterpreterDetection::id_to_triplet(c$id);
	if ( trip in flagged )
		return;

	add flagged[trip];

	local message = fmt("Meterpreter detected with reason=TIMING_DETECTED, protocol=HTTP, os=WINDOWS");
	MeterpreterDetection::log_a_notice(c, message,
	    MeterpreterDetection::Meterpreter_Detected, T);
	}

event http_reply(c: connection, version: string, code: count, reason: string)
	{
	if ( c$id !in win_polling_data )
		win_polling_data[c$id] = polling_state();

	local current_state = win_polling_data[c$id];
	current_state$last_delay = network_time() - current_state$last_timestamp;
	}
